
Partial Class _Default
    Inherits System.Web.UI.Page

    Public Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        If initialization.Text = "new" Then
            x.Text = "0"
            y.Text = "0"
            z.Text = "1"
            i.Text = "10"
            initialization.Text = "old"
            If Len(Request.QueryString("cameraurl")) > 0 Then CameraURL.Text = Request.QueryString("cameraurl")
            If Len(Request.QueryString("x1")) > 0 Then x1.Text = Request.QueryString("x1") Else x1.Text = "0"
            If Len(Request.QueryString("x2")) > 0 Then x2.Text = Request.QueryString("x2") Else x2.Text = "0"
            If Len(Request.QueryString("x3")) > 0 Then x3.Text = Request.QueryString("x3") Else x3.Text = "0"
            If Len(Request.QueryString("x4")) > 0 Then x4.Text = Request.QueryString("x4") Else x4.Text = "0"
            If Len(Request.QueryString("x5")) > 0 Then x5.Text = Request.QueryString("x5") Else x5.Text = "0"
            If Len(Request.QueryString("y1")) > 0 Then y1.Text = Request.QueryString("y1") Else y1.Text = "0"
            If Len(Request.QueryString("y2")) > 0 Then y2.Text = Request.QueryString("y2") Else y2.Text = "0"
            If Len(Request.QueryString("y3")) > 0 Then y3.Text = Request.QueryString("y3") Else y3.Text = "0"
            If Len(Request.QueryString("y4")) > 0 Then y4.Text = Request.QueryString("y4") Else y4.Text = "0"
            If Len(Request.QueryString("y5")) > 0 Then y5.Text = Request.QueryString("y5") Else y5.Text = "0"
            If Len(Request.QueryString("z1")) > 0 Then z1.Text = Request.QueryString("z1") Else z1.Text = "1"
            If Len(Request.QueryString("z2")) > 0 Then z2.Text = Request.QueryString("z2") Else z2.Text = "1"
            If Len(Request.QueryString("z3")) > 0 Then z3.Text = Request.QueryString("z3") Else z3.Text = "1"
            If Len(Request.QueryString("z4")) > 0 Then z4.Text = Request.QueryString("z4") Else z4.Text = "1"
            If Len(Request.QueryString("z5")) > 0 Then z5.Text = Request.QueryString("z5") Else z5.Text = "1"

            ' Set the initial location to what is stored in position 1
            x.Text = x1.Text
            y.Text = y1.Text
            z.Text = z1.Text
            SetPos()
            SetZoom()
            UpdateBookmark()
        End If
    End Sub

#Region "Utility"

    Public Sub SetZoom()
        Dim zz As Double
        zz = Val(z.Text)
        If zz > 2 Then zz = 2
        If zz < 1 Then zz = 1
        z.Text = zz.ToString
        If CameraURL.Text <> "" Then
            FetchHttp("http://" + CameraURL.Text + "/zoom-" + zz.ToString)
        End If
        UpdateBookmark()
    End Sub

    Public Sub SetPos()
        Dim sURL As String
        Dim xx As Integer
        Dim yy As Integer
        xx = Val(x.Text)
        yy = Val(y.Text)
        If xx > 100 Then xx = 100
        If xx < -100 Then xx = -100
        If yy > 100 Then yy = 100
        If yy < -100 Then yy = -100
        x.Text = xx.ToString
        y.Text = yy.ToString
        sURL = "http://" + CameraURL.Text + "/pos-" + xx.ToString + "," + yy.ToString
        If CameraURL.Text <> "" Then
            FetchHttp(sURL)
        End If
        lblURL.Text = sURL
        UpdateBookmark()
    End Sub

    Public Sub FetchHttp(ByVal URL As String)
        Dim Request As System.Net.HttpWebRequest = System.Net.WebRequest.Create(URL)
        Request.Method = "GET"
        Request.Timeout = 1000
        Try
            Dim Response As System.Net.HttpWebResponse = Request.GetResponse()
            Dim StreamReader As System.IO.StreamReader = New System.IO.StreamReader(Response.GetResponseStream())
            Dim HTMLResponse As String = StreamReader.ReadToEnd()
            StreamReader.Close()
            Response.Close()
            txtHTTPResponse.Text = HTMLResponse
        Catch ex As Exception
            Return
        End Try
        Return
    End Sub

    Protected Sub UpdateBookmark()
        Dim surl As String
        surl = "http://" + Request.Url.Authority + Request.Path
        surl = surl + "?cameraurl=" + CameraURL.Text
        surl = surl + "&x1=" + x1.Text
        surl = surl + "&x2=" + x2.Text
        surl = surl + "&x3=" + x3.Text
        surl = surl + "&x4=" + x4.Text
        surl = surl + "&x5=" + x5.Text
        surl = surl + "&y1=" + y1.Text
        surl = surl + "&y2=" + y2.Text
        surl = surl + "&y3=" + y3.Text
        surl = surl + "&y4=" + y4.Text
        surl = surl + "&y5=" + y5.Text
        surl = surl + "&z1=" + z1.Text
        surl = surl + "&z2=" + z2.Text
        surl = surl + "&z3=" + z3.Text
        surl = surl + "&z4=" + z4.Text
        surl = surl + "&z5=" + z5.Text
        bookmarkLink.NavigateUrl = surl
        bookmarkLink.Text = "Bookmarkable"
        Me.Page.Title = "PTZ Web - " + CameraURL.Text
    End Sub

#End Region

#Region "Buttons"

#Region "Arrows"

    Protected Sub UL_Click(ByVal sender As Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles UL.Click
        x.Text = (Val(x.Text) - Val(i.Text)).ToString
        y.Text = (Val(y.Text) + Val(i.Text)).ToString
        SetPos()
    End Sub

    Protected Sub U_Click(ByVal sender As Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles U.Click
        y.Text = (Val(y.Text) + Val(i.Text)).ToString
        SetPos()
    End Sub

    Protected Sub UR_Click(ByVal sender As Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles UR.Click
        x.Text = (Val(x.Text) + Val(i.Text)).ToString
        y.Text = (Val(y.Text) + Val(i.Text)).ToString
        SetPos()
    End Sub

    Protected Sub L_Click(ByVal sender As Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles L.Click
        x.Text = (Val(x.Text) - Val(i.Text)).ToString
        SetPos()
    End Sub

    Protected Sub H_Click(ByVal sender As Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles H.Click
        x.Text = "0"
        y.Text = "0"
        z.Text = "1"
        SetPos()
        SetZoom()
    End Sub

    Protected Sub R_Click(ByVal sender As Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles R.Click
        x.Text = (Val(x.Text) + Val(i.Text)).ToString
        SetPos()
    End Sub

    Protected Sub DL_Click(ByVal sender As Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles DL.Click
        x.Text = (Val(x.Text) - Val(i.Text)).ToString
        y.Text = (Val(y.Text) - Val(i.Text)).ToString
        SetPos()
    End Sub

    Protected Sub D_Click(ByVal sender As Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles D.Click
        y.Text = (Val(y.Text) - Val(i.Text)).ToString
        SetPos()
    End Sub

    Protected Sub DR_Click(ByVal sender As Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles DR.Click
        x.Text = (Val(x.Text) + Val(i.Text)).ToString
        y.Text = (Val(y.Text) - Val(i.Text)).ToString
        SetPos()
    End Sub

#End Region

#Region "Zoom"

    Protected Sub ZMinus_Click(ByVal sender As Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles ZMinus.Click
        z.Text = (Val(z.Text) - (Val(i.Text) / 100)).ToString
        SetZoom()
    End Sub

    Protected Sub zplus_Click(ByVal sender As Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles zplus.Click
        z.Text = (Val(z.Text) + (Val(i.Text) / 100)).ToString
        SetZoom()
    End Sub

#End Region

#Region "Increment Control"

    Protected Sub small_Click(ByVal sender As Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles small.Click
        i.Text = "5"
    End Sub

    Protected Sub medium_Click(ByVal sender As Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles medium.Click
        i.Text = "10"
    End Sub

    Protected Sub large_Click(ByVal sender As Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles large.Click
        i.Text = "20"
    End Sub

#End Region

#Region "Select Preset"

    Protected Sub p1_Click(ByVal sender As Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles p1.Click
        x.Text = x1.Text
        y.Text = y1.Text
        z.Text = z1.Text
        SetPos()
        SetZoom()
    End Sub

    Protected Sub P2_Click(ByVal sender As Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles P2.Click
        x.Text = x2.Text
        y.Text = y2.Text
        z.Text = z2.Text
        SetPos()
        SetZoom()
    End Sub

    Protected Sub P3_Click(ByVal sender As Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles P3.Click
        x.Text = x3.Text
        y.Text = y3.Text
        z.Text = z3.Text
        SetPos()
        SetZoom()
    End Sub

    Protected Sub P4_Click(ByVal sender As Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles P4.Click
        x.Text = x4.Text
        y.Text = y4.Text
        z.Text = z4.Text
        SetPos()
        SetZoom()
    End Sub

    Protected Sub P5_Click(ByVal sender As Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles P5.Click
        x.Text = x5.Text
        y.Text = y5.Text
        z.Text = z5.Text
        SetPos()
        SetZoom()
    End Sub

#End Region

#Region "Save Preset"

    Protected Sub S1_Click(ByVal sender As Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles S1.Click
        x1.Text = x.Text
        y1.Text = y.Text
        z1.Text = z.Text
    End Sub

    Protected Sub S2_Click(ByVal sender As Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles S2.Click
        x2.Text = x.Text
        y2.Text = y.Text
        z2.Text = z.Text
    End Sub

    Protected Sub S3_Click(ByVal sender As Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles S3.Click
        x3.Text = x.Text
        y3.Text = y.Text
        z3.Text = z.Text
    End Sub

    Protected Sub S4_Click(ByVal sender As Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles S4.Click
        x4.Text = x.Text
        y4.Text = y.Text
        z4.Text = z.Text
    End Sub

    Protected Sub S5_Click(ByVal sender As Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles S5.Click
        x5.Text = x.Text
        y5.Text = y.Text
        z5.Text = z.Text
    End Sub

#End Region

#End Region

    Protected Sub btnQ_Click(ByVal sender As Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles btnQ.Click
        btnHelp.Visible = True
        btnQ.Visible = False
    End Sub

    Protected Sub btnHelp_Click(ByVal sender As Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles btnHelp.Click
        btnQ.Visible = True
        btnHelp.Visible = False
    End Sub
End Class
